#!/usr/bin/env bash
# This code is included in /hive/bin/custom function

NEWLINE=$'\n'

[[ -z $CUSTOM_TEMPLATE ]] && echo -e "${YELLOW}CUSTOM_TEMPLATE is empty${NOCOLOR}" && return 1
#[[ -z $CUSTOM_URL ]] && echo -e "${YELLOW}CUSTOM_URL is empty${NOCOLOR}" && return 1

CUSTOM_ALGO=bismuth
conf="address = \"${CUSTOM_TEMPLATE}\"${NEWLINE}#%WORKER_NAME%${NEWLINE}${NEWLINE}#%CUSTOM_USER_CONFIG%${NEWLINE}"

#replace tpl values in whole file
[[ ! -z $WORKER_NAME ]] && conf=$(sed "s/#%WORKER_NAME%/minerName = \"Hive-$WORKER_NAME\"/g" <<< "$conf")
[[ ! -z $CUSTOM_USER_CONFIG ]] && conf=$(perl -0777 -ne "s/#%CUSTOM_USER_CONFIG%/$CUSTOM_USER_CONFIG/g;print" <<< "$conf")

[[ -z $CUSTOM_CONFIG_FILENAME ]] && echo -e "${RED}No CUSTOM_CONFIG_FILENAME is set${NOCOLOR}" && return 1
echo "$conf" > $CUSTOM_CONFIG_FILENAME
