#!/usr/bin/env bash

#######################
# Functions
#######################


get_cards_hashes(){
	# hs is global
	hs=(0)
	for (( i=0; i < ${GPU_COUNT}; i++ )); do
		#cat EggMinerGpuLin3/test.log |tail -n 10|grep GPU0|tail -n 1|tr '|,' ' '|cut -b 2- |awk '{ printf $8 }'

		#local MHS=`cat $LOG_NAME | grep "$(echo $i | awk '{printf("Stats GPU%2d",$1)}')" | tail -n 1 | sed 's/^.*\(lyra2z*\)/\1/g' | awk '{ printf $2"\n" }' | sed -e 's/M.*//'`
		#hs[$i]=`echo $MHS | awk '{ printf("%.f",$1*1000) }'`
		#local MHS=`cat EggMinerGpuLin3/test.log |tail -n 10|grep GPU0|tail -n 1|tr '|' ' '|cut -b 3- |sed 's/MH\/s//g'|tr ',' '\n'|grep "$(echo $i | awk '{printf("GPU%d",$1)}')"|awk '{ printf $2 }'`
		#local MHS=`cat $LOG_NAME |tail -n 10|grep GPU0|tail -n 1|tr '|' ' '|cut -b 3- |sed 's/MH\/s//g'|tr ',' '\n'|grep "$(echo $i | awk '{printf("GPU%d",$1)}')"|awk '{ printf $2 }'`
		local MHS=`cat $LOG_NAME |tail -n 10|grep GPU0|tail -n 1|tr '|' ' '|tr -dc '[:alnum:],|\/: '|sed 's/37m //g'|sed 's/MH\/s//g'|tr ',' '\n'|grep "$(echo $i | awk '{printf("GPU%d",$1)}')"|awk '{ printf $2 }'`
		hs[$i]=`echo $MHS | awk '{ printf("%.f",$1*1000) }'`
	done
}

get_miner_uptime(){
	#local tmp=$(cat $LOG_NAME | head -n 3 | tail -n 1 | sed -e 's/].*//' | cut -b 2- )
	#local start=$(date +%s -d "$tmp")
	#local now=$(date +%s)
	#echo $((now - start))
	#local tmp=$(cat $LOG_NAME |tail -n 20|grep Uptime|tail -n 1|awk '{ printf $6"\n" }'|sed 's/H.//g'|awk '{printf "%.f",$1*3600}')
	local tmp=$(cat $LOG_NAME |tail -n 20|grep Uptime|tail -n 1|tr -dc '[:alnum:],|\/: >\.'|sed 's/37m //g'|sed 's/H./ /g'|awk '{ printf $6"\n" }'|awk '{printf "%.f",$1*3600}')
	echo $tmp
}

get_total_hashes(){
	# khs is global
	local Total=`cat ${LOG_NAME} | grep -a "> Total" | tail -n 1 | cut -d " " -f4 | awk '{printf "%.f",$1*1000000}'`
	echo $Total
}

get_log_time_diff(){
	local getLastLogTime=`tail -n 100 $LOG_NAME | grep -a "Stats Total" | tail -n 1 | awk {'print $1,$2'} | sed 's/[][]//g'`
	local logTime=`date --date="$getLastLogTime" +%s`
	local curTime=`date +%s`
	#echo `expr $curTime - $logTime`
}

#######################
# MAIN script body
#######################

[[ -z $GPU_COUNT_NVIDIA ]] &&
	GPU_COUNT_NVIDIA=`gpu-detect NVIDIA`
[[ -z $GPU_COUNT_AMD ]] &&
	GPU_COUNT_AMD=`gpu-detect AMD`

GPU_COUNT=`expr $GPU_COUNT_NVIDIA + $GPU_COUNT_AMD`
echo gpu count: $GPU_COUNT


. /hive/custom/$CUSTOM_MINER/h-manifest.conf
#. ./h-manifest.conf
LOG_NAME="$CUSTOM_LOG_BASENAME.log"


# Calc log freshness
# local diffTime=$(get_log_time_diff)
#local maxDelay=120
diffTime=$(get_log_time_diff)
maxDelay=250

echo $diffTime

# If log is fresh the calc miner stats or set to null if not
# if [ "$diffTime" -lt "$maxDelay" ]; then
if [ 1 ]; then
	get_cards_hashes				# hashes array
	# echo ${hs[@]}
	hs_units='khs'					# hashes utits
	uptime=$(get_miner_uptime)		# miner uptime
	echo uptime: $uptime
	algo="bismuth"					# algo
	# A/R shares by pool
	# ac=`cat $LOG_NAME | grep "Pool" | grep -c "share accepted"`
	# ac=`cat $LOG_NAME |tail -n 20|grep "ok shares Total"|tail -n 1|awk '{ printf $2"\n" }'`
	ac=`cat $LOG_NAME |tail -n 20|grep "ok shares Total"|tr -dc '[:alnum:],|\/: '|tail -n 1|awk '{ printf $3"\n" }'`
	rj=0

	# make JSON
	stats=$(jq -nc \
				--argjson hs "`echo ${hs[@]} | tr " " "\n" | jq -cs '.'`" \
				--arg hs_units "$hs_units" \
				--arg uptime "$uptime" \
				--arg ac $ac --arg rj "$rj" \
				--arg algo "$algo" \
				'{$hs, $hs_units, $uptime, ar: [$ac, $rj], $algo}')
	# total hashrate in khs
	khs=$(get_total_hashes)
else
	stats=""
	khs=0
fi

# debug output

echo stats: $stats
echo khs:   $khs
